-------------------------------------------------------------------------------
--
-- Title       : top
-- Design      : Projekt_FIR
-- Author      : Jerzy Kasperek & Pawe J.Rajda
-- Company     : Katedra Elektroniki AGH
--
-------------------------------------------------------------------------------
--
-- AHDL <=> MATLAB przykadowy projekt pokazujacy kosymulacje w obu rodowiskach
--
-------------------------------------------------------------------------------


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.STD_LOGIC_unsigned.all;


-- Deklaracje bibliotek do kosymulacji MATLAB/AHDL
library aldec;
use aldec.matlab.all;

-- 
entity top is
	port(
		reset : in STD_LOGIC;
		ce : in std_logic;
		clk : in std_logic
		);
end top;

architecture top of top is
	
	---- Component declarations -----
	
	-------------------------------------------------------------------------------
	-- Module signal_generator
	-- virtual module responsibile for input data reading...
	-- In real designs it could be for example an A/D converter interface....	
	-------------------------------------------------------------------------------
	component signal_generator
		port (
			clk : in STD_LOGIC;
			reset : in STD_LOGIC;
			data_out : out STD_LOGIC_vector(15 downto 0)
			);
	end component;
	-------------------------------------------------------------------------------
	-- Module signal_receiver
	-- virtual module responsibile for output data writing...
	-- In real designs it could be for example an D/A converter interface....	
	-------------------------------------------------------------------------------
	component signal_receiver
		port (
			clk : in STD_LOGIC;
			data_in : in STD_LOGIC_vector(15 downto 0);
			reset : in STD_LOGIC
			);
	end component;
	-------------------------------------------------------------------------------
	-- Main "active" module of the tutorial design 	
	-- Actually this is UUT  (Unit Under Test) module
	-------------------------------------------------------------------------------
	
	component pdafir
		port  (
			clk :in std_logic;
			ce :in std_logic; 
			rst :in std_logic;  
			x : in std_logic_vector(15 downto 0);
			y : out std_logic_vector(15 downto 0)
			);
	end component;
	---- Signal declarations used on the diagram ----
	
	signal data_in : STD_LOGIC_vector(15 downto 0);
	signal data_out : STD_LOGIC_vector(15 downto 0);
	
begin
	
	----  Component instantiations  ----
	
	
	U2 : signal_generator
	port map(
		clk => clk,
		data_out => data_in,
		reset => reset
		);
	
	U3 : signal_receiver
	port map(
		clk => clk,
		data_in => data_out,
		reset => reset
		);
	
	U4 : pdafir
	port map(	
		ce => ce,
		clk => clk,
		rst => reset,
		x => data_in,
		y => data_out
		);
	
	
end top;
